using Exferia_KairosPRO._1_Modelos.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_KairosPRO_EF;
using static Exferia_Aplicacion.General.Enumerados;
using System.Transactions;
using System.Data.SqlClient;

namespace Exferia_KairosPRO._2_Datos
{
    public class KRS_Empleados_TraspasoBiometria_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_RegistroListado(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_id)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_Listado(KairosProEntities _dbcontext, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_id)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(KairosProEntities _dbcontext, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {

        }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_F3(KairosProEntities _dbcontext, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {

        }
        #endregion

        #region Obtener
        public override dynamic Obtener(long _lng_id)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_CampoBusqueda, string _str_Filtro)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private KRS_Empleados_TraspasoBiometria g_mdl_KRS_Empleados_TraspasoBiometria = null;
        public KRS_Empleados_TraspasoBiometria Obtener_Modelo_Por_Id(long _lng_id, long _lng_CodigoCliente)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " +
                                        nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.id) + "=@id and " +
                                        nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id),
                     new SqlParameter("@codigoCliente",  _lng_CodigoCliente)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                            arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Empleados_TraspasoBiometria_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_KRS_Empleados_TraspasoBiometria;
        }
        public KRS_Empleados_TraspasoBiometria Obtener_Modelo_Por_TerminalEmpleado(long _lng_idTerminal, long _lng_idEmpleado)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " +
                                        nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.idTerminal) + "=@idTerminal and " +
                                        nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.idEmpleado) + "=@idEmpleado and " +
                                        nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idTerminal",  _lng_idTerminal),
                     new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                     new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                            arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Empleados_TraspasoBiometria_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_KRS_Empleados_TraspasoBiometria;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL, object[] _arr_Parametros)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el Modelo
                g_mdl_KRS_Empleados_TraspasoBiometria = obj_KairosProEntities.Database.SqlQuery<KRS_Empleados_TraspasoBiometria>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Empleados_TraspasoBiometria_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }

        #endregion

        #region Modelo Listado
        private List<KRS_Empleados_TraspasoBiometria> g_lst_KRS_Empleados_TraspasoBiometria = null;

        public List<KRS_Empleados_TraspasoBiometria> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(KRS_Empleados_TraspasoBiometria),
                                                                                           nameof(KRS_Empleados_TraspasoBiometria.id),
                                                                                           G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                           _lst_Ids);


                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " + nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.codigoCliente) + "=@codigoCliente and " +
                                       str_Filtros_IDS;

                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO));

                    object[] arr_Parametros = lst_Parametros.ToArray();

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     arr_Parametros);

                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Empleados_TraspasoBiometria_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_KRS_Empleados_TraspasoBiometria;
        }
        public List<KRS_Empleados_TraspasoBiometria> Obtener_ModeloListado_Por_IdEmpleado(long _lng_idEmpleado)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " + 
                                            nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.idEmpleado) + "=@idEmpleado and " +
                                            nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                     new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                };
                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Empleados_TraspasoBiometria_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_KRS_Empleados_TraspasoBiometria;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros)
        {
            KairosProEntities obj_KairosProEntities = null;
            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_KRS_Empleados_TraspasoBiometria = obj_KairosProEntities.Database.SqlQuery<KRS_Empleados_TraspasoBiometria>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Empleados_TraspasoBiometria_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.id) + " , " +
                    nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.codigoCliente) + " , " +
                    nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.idEmpleado) + " , " +
                    nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.idTerminal) + " , " +
                    nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.traspasado) + " , " +
                    nameof(KRS_Empleados_TraspasoBiometria) + "." + nameof(KRS_Empleados_TraspasoBiometria.tipoAccion) +
                " FROM " + nameof(KRS_Empleados_TraspasoBiometria);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                bool bol_Grabar = false;

                KRS_Empleados_TraspasoBiometria mdl_KRS_Empleados_TraspasoBiometria_AGrabar = (KRS_Empleados_TraspasoBiometria)_mdl_obj;
                KRS_Empleados_TraspasoBiometria mdl_KRS_Empleados_TraspasoBiometria_DatosViejos = new KRS_Empleados_TraspasoBiometria();

                KRS_Empleados_TraspasoBiometria mdl_KRS_Empleados_TraspasoBiometria_Final = Obtener_Modelo_Por_TerminalEmpleado(mdl_KRS_Empleados_TraspasoBiometria_AGrabar.idTerminal, mdl_KRS_Empleados_TraspasoBiometria_AGrabar.idEmpleado);

                if (mdl_KRS_Empleados_TraspasoBiometria_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //id
                    mdl_KRS_Empleados_TraspasoBiometria_AGrabar.id = mdl_KRS_Empleados_TraspasoBiometria_Final.id;

                    //Se cambia el tipo de acción a 3 (Modificar)
                    if (!mdl_KRS_Empleados_TraspasoBiometria_AGrabar.tipoAccion.Equals(Variables.G_STR_TIPOACCION_ELIMINAR))
                    {
                        //Si esta traspasado
                        if (mdl_KRS_Empleados_TraspasoBiometria_Final.traspasado)
                        {
                            mdl_KRS_Empleados_TraspasoBiometria_AGrabar.tipoAccion = "3";
                        }
                        //Si no esta traspasado miramos si tipo 2 (ya que nunca podra estar traspasado)
                        else if (mdl_KRS_Empleados_TraspasoBiometria_Final.tipoAccion.Equals("2"))
                        {
                            mdl_KRS_Empleados_TraspasoBiometria_AGrabar.tipoAccion = "3";
                        }
                    }
                    else
                    {
                        //Se cambia el tipo de acción a 2 (Borrar)
                        mdl_KRS_Empleados_TraspasoBiometria_AGrabar.tipoAccion = "2";
                    }

                    //Validado el codigo del cliente, se lo asignamos antes de grabar
                    mdl_KRS_Empleados_TraspasoBiometria_AGrabar.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                    //Datos viejos para la trazabilidar
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_Empleados_TraspasoBiometria_Final, mdl_KRS_Empleados_TraspasoBiometria_DatosViejos, false, false);

                    //Cargar los Datos del modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_Empleados_TraspasoBiometria_AGrabar, mdl_KRS_Empleados_TraspasoBiometria_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(KRS_Empleados_TraspasoBiometria) +
                                           " SET " +
                                                nameof(KRS_Empleados_TraspasoBiometria.codigoCliente) + "=@codigoCliente," +
                                                nameof(KRS_Empleados_TraspasoBiometria.idEmpleado) + "=@idEmpleado," +
                                                nameof(KRS_Empleados_TraspasoBiometria.idTerminal) + "=@idTerminal," +
                                                nameof(KRS_Empleados_TraspasoBiometria.traspasado) + "=@traspasado," +
                                                nameof(KRS_Empleados_TraspasoBiometria.tipoAccion) + "=@tipoAccion" +
                                           " WHERE " +
                                               nameof(KRS_Empleados_TraspasoBiometria.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigoCliente",  mdl_KRS_Empleados_TraspasoBiometria_Final.codigoCliente),
                        new SqlParameter("@idEmpleado", mdl_KRS_Empleados_TraspasoBiometria_Final.idEmpleado),
                        new SqlParameter("@idTerminal", mdl_KRS_Empleados_TraspasoBiometria_Final.idTerminal),
                        new SqlParameter("@traspasado", mdl_KRS_Empleados_TraspasoBiometria_Final.traspasado),
                        new SqlParameter("@tipoAccion", mdl_KRS_Empleados_TraspasoBiometria_Final.tipoAccion),
                        new SqlParameter("@id", mdl_KRS_Empleados_TraspasoBiometria_Final.id)
                    };
                    #endregion

                    //Update
                    obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_KRS_Empleados_TraspasoBiometria_Final.id;


                    bol_Grabar = true;
                }
                else
                {
                    //Si no es eliminar
                    if (!mdl_KRS_Empleados_TraspasoBiometria_AGrabar.tipoAccion.Equals(Variables.G_STR_TIPOACCION_ELIMINAR))
                    {
                        mdl_KRS_Empleados_TraspasoBiometria_Final = new KRS_Empleados_TraspasoBiometria();

                        //Tipo de Accion que se va a realizar
                        mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                        //Validado el codigo del cliente, se lo asignamos antes de grabar
                        mdl_KRS_Empleados_TraspasoBiometria_AGrabar.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                        //Cargar los Datos del modelo
                        Funciones.CopiarPropiedadesObjetos(mdl_KRS_Empleados_TraspasoBiometria_AGrabar, mdl_KRS_Empleados_TraspasoBiometria_Final, false, false);

                        #region INSERT
                        string str_SQL_Insert = " INSERT INTO " + nameof(KRS_Empleados_TraspasoBiometria) +
                                                   " (" +
                                                            nameof(KRS_Empleados_TraspasoBiometria.codigoCliente) + "," +
                                                            nameof(KRS_Empleados_TraspasoBiometria.idEmpleado) + "," +
                                                            nameof(KRS_Empleados_TraspasoBiometria.idTerminal) + "," +
                                                            nameof(KRS_Empleados_TraspasoBiometria.traspasado) + "," +
                                                            nameof(KRS_Empleados_TraspasoBiometria.tipoAccion) + 
                                                   " ) " +
                                                   " OUTPUT INSERTED." + nameof(KRS_Empleados_TraspasoBiometria.id) +
                                                   " VALUES " +
                                                   " ( " +
                                                       "@codigoCliente," +
                                                       "@idEmpleado," +
                                                       "@idTerminal," +
                                                       "@traspasado," +
                                                       "@tipoAccion" +
                                                   " ) ";

                        //Parametros
                        object[] arr_Parametros_Insert = new object[]
                        {
                            new SqlParameter("@codigoCliente",  mdl_KRS_Empleados_TraspasoBiometria_Final.codigoCliente),
                            new SqlParameter("@idEmpleado", mdl_KRS_Empleados_TraspasoBiometria_Final.idEmpleado),
                            new SqlParameter("@idTerminal", mdl_KRS_Empleados_TraspasoBiometria_Final.idTerminal),
                            new SqlParameter("@traspasado", mdl_KRS_Empleados_TraspasoBiometria_Final.traspasado),
                            new SqlParameter("@tipoAccion", mdl_KRS_Empleados_TraspasoBiometria_Final.tipoAccion)
                        };
                        #endregion

                        //Id de la tabla
                        mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_KairosProEntities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();


                        bol_Grabar = true;
                    }
                }

                //Ver si hay que grabar
                if (bol_Grabar)
                {
                    //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                    USR_Trazabilidad_Datos.Grabar_Trazabilidad(typeof(KRS_Empleados_TraspasoBiometria), mdl_KRS_Empleados_TraspasoBiometria_DatosViejos, mdl_KRS_Empleados_TraspasoBiometria_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_KairosProEntities);
                }
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Empleados_TraspasoBiometria_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            KRS_Empleados_TraspasoBiometria mdl_KRS_Empleados_TraspasoBiometria_Final = null;

            try
            {
                //Intento
                using (KairosProEntities dbcontext = new KairosProEntities())
                {
                    dbcontext.Configuration.LazyLoadingEnabled = false;

                    var valorDevuelto = dbcontext.KRS_Empleados_TraspasoBiometria.Where(m => m.id.Equals(_lng_id) && m.codigoCliente.Equals(Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO));
                    if (valorDevuelto != null && valorDevuelto.Count() > 0)
                    {
                        mdl_KRS_Empleados_TraspasoBiometria_Final = valorDevuelto.FirstOrDefault();


                        dbcontext.KRS_Empleados_TraspasoBiometria.Remove(mdl_KRS_Empleados_TraspasoBiometria_Final);
                        dbcontext.SaveChanges();

                        // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                        USR_Trazabilidad_Datos.Grabar_Trazabilidad(typeof(KRS_Empleados_TraspasoBiometria), null, mdl_KRS_Empleados_TraspasoBiometria_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, dbcontext);
                    }
                }
                // Devolver también el Objeto
                mdl_ValorDevuelto_Modelo.Id = mdl_KRS_Empleados_TraspasoBiometria_Final.id;
            }

            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Empleados_TraspasoBiometria_Datos) + "/" + nameof(Borrar), true);
            }
            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        #endregion
    }
}
